package cn.com.infosec.crypto.modes;

import cn.com.infosec.crypto.BlockCipher;
import cn.com.infosec.crypto.CipherParameters;
import cn.com.infosec.crypto.params.ParametersWithIV;

public class SICBlockCipher implements BlockCipher {
   private final BlockCipher cipher;
   private final int blockSize;
   private byte[] IV;
   private byte[] counter;
   private byte[] counterOut;

   public SICBlockCipher(BlockCipher c) {
      SICBlockCipher var10000 = this;
      SICBlockCipher var10001 = this;
      SICBlockCipher var10002 = this;
      super();
      this.cipher = c;
      int var2;
      this.blockSize = var2 = c.getBlockSize();
      var10002.IV = new byte[var2];
      var10001.counter = new byte[var2];
      var10000.counterOut = new byte[var2];
   }

   public BlockCipher getUnderlyingCipher() {
      return this.cipher;
   }

   public void init(boolean forEncryption, CipherParameters params) {
      if (params instanceof ParametersWithIV) {
         SICBlockCipher var10000 = this;
         SICBlockCipher var10001 = this;
         ParametersWithIV forEncryption1;
         byte[] var10002 = (forEncryption1 = (ParametersWithIV)params).getIV();
         byte[] var3;
         int params1 = (var3 = this.IV).length;
         System.arraycopy(var10002, 0, var3, 0, params1);
         var10001.reset();
         var10000.cipher.init(true, forEncryption1.getParameters());
      }

   }

   public String getAlgorithmName() {
      return this.cipher.getAlgorithmName() + "/SIC";
   }

   public int getBlockSize() {
      return this.cipher.getBlockSize();
   }

   public int processBlock(byte[] in, int inOff, byte[] out, int outOff) {
      byte[] var5 = this.counter;
      byte[] var6 = this.counterOut;
      this.cipher.processBlock(var5, 0, var6, 0);

      for(int var9 = 0; var9 < (var6 = this.counterOut).length; ++var9) {
         int var10 = outOff + var9;
         out[var10] = (byte)(var6[var9] ^ in[inOff + var9]);
      }

      int in1 = 1;

      byte outOff1;
      for(inOff = this.counter.length - 1; inOff >= 0; in1 = outOff1) {
         if ((in1 += (out = this.counter)[inOff] & 255) > 255) {
            outOff1 = 1;
         } else {
            outOff1 = 0;
         }

         out[inOff] = (byte)in1;
         --inOff;
      }

      return this.counter.length;
   }

   public void reset() {
      SICBlockCipher var10000 = this;
      byte[] var10001 = this.IV;
      byte[] var2;
      int var1 = (var2 = this.counter).length;
      System.arraycopy(var10001, 0, var2, 0, var1);
      var10000.cipher.reset();
   }
}
